package net.nexcius.gesturerecognizer.datamanipulation;

import java.util.List;

import be.ac.ulg.montefiore.run.jahmm.ObservationVector;

import net.nexcius.gesturerecognizer.inputypes.NVec3;
import net.nexcius.gesturerecognizer.inputypes.Vec3;

public class IsolateGesture {
	public static List<Vec3> isolateGesture(List<Vec3> vectors, float treshold) {
		int beginIndex = 0;
		int endIndex = vectors.size() - 1;
		
		for(int i = 0; i < vectors.size(); i++) {
			if(vectors.get(i).getGravitationalMagnitude() < treshold) {
				beginIndex = i;
			} else {
				break;
			}
		}
		
		for(int i = vectors.size()-1; i >= 0 ; i--) {
			if(vectors.get(i).getGravitationalMagnitude() < treshold) {
				endIndex = i;
				
			} else {
				break;
			}
		}
		
		if(endIndex > beginIndex) {
			return vectors.subList(beginIndex, endIndex);
		}
		
		vectors.clear();
		return vectors;
	}
	
	
	
	public static List<ObservationVector> isolateGestureObs(List<ObservationVector> vectors, float treshold) {
		int beginIndex = 0;
		int endIndex = vectors.size() - 1;
		
		for(int i = 0; i < vectors.size(); i++) {
			float x = (float) vectors.get(i).value(0);
			float y = (float) vectors.get(i).value(1);
			float z = (float) vectors.get(i).value(2);
			
			float len = (float) Math.sqrt((x * x) + (y * y) + (z * z));
			float magLen =  Math.abs(len - Vec3.GRAVITY);
					
			if(magLen < treshold) {
				beginIndex = i;
			} else {
				break;
			}
		}
		
		for(int i = vectors.size()-1; i >= 0 ; i--) {
			float x = (float) vectors.get(i).value(0);
			float y = (float) vectors.get(i).value(1);
			float z = (float) vectors.get(i).value(2);
			
			float len = (float) Math.sqrt((x * x) + (y * y) + (z * z));
			float magLen =  Math.abs(len - Vec3.GRAVITY);
			
			if(magLen < treshold) {
				endIndex = i;
				
			} else {
				break;
			}
		}

		
		if(endIndex > beginIndex) {
			return vectors.subList(beginIndex, endIndex);
		}
		
		vectors.clear();
		return vectors;
	}
	
	
	public static List<NVec3> isolateGestureNVec(List<NVec3> vectors, float treshold) {
		int beginIndex = 0;
		int endIndex = vectors.size() - 1;
		
		for(int i = 0; i < vectors.size(); i++) {
			if(vectors.get(i).getGravitationalMagnitude() < treshold) {
				beginIndex = i;
			} else {
				break;
			}
		}
		
		for(int i = vectors.size()-1; i >= 0 ; i--) {
			if(vectors.get(i).getGravitationalMagnitude() < treshold) {
				endIndex = i;
				
			} else {
				break;
			}
		}
		
		if(endIndex > beginIndex) {
			return vectors.subList(beginIndex, endIndex);
		}
		
		vectors.clear();
		return vectors;
	}
}
