package net.nexcius.gesturerecognizer.support;

import java.util.ArrayList;
import java.util.List;

public class ResultList {
	private List<String> handles;
	private List<Double> certainties;
	
	private int size = 0;
	
	public ResultList() {
		handles = new ArrayList<String>();
		certainties = new ArrayList<Double>();
	}
	
	public void add(String handle, double certainty) {
		
		if(size == 0) {
			handles.add(handle);
			certainties.add(certainty);
			
		} else {
			int addAt = size;
			
			for(int i = 0; i < size; i++) {
				if(certainty > certainties.get(i)) {
					addAt = i;
					break;
				}
			}
			handles.add(addAt, handle);
			certainties.add(addAt, certainty);
		}
		
		size++;
	}
	
	public String getTopHandle() {
		return handles.get(0);
	}
	
	public double getTopCertainty() {
		return certainties.get(0);
	}
	
	public int getSize() {
		return size;
	}
	
	public void print() {
		System.out.println("Printing result list:");
		for(int i = 0; i < size; i++) {
			System.out.println(handles.get(i) + ": " + certainties.get(i));
		}
		System.out.println(" ");
	}
}
