package net.nexcius.gesturerecognizer.support;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import be.ac.ulg.montefiore.run.jahmm.ObservationVector;

import net.nexcius.gesturerecognizer.inputypes.NVec3;
import net.nexcius.gesturerecognizer.inputypes.Vec3;

public class SequenceLoader {
	
	public static List<List<Vec3>> getVecSequences(String filename) {
		List<List<Vec3>> sequences = new ArrayList<List<Vec3>>();
		
		try {
            BufferedReader in = new BufferedReader(new FileReader(filename));
            String strLine = "";

            while((strLine = in.readLine()) != null) {
            	List<Vec3> sequence = new ArrayList<Vec3>();
            	
            	strLine = strLine.trim();
            	String fragments[] = strLine.split(";");
            	
            	float x = 0.0f;
            	float y = 0.0f;
            	float z = 0.0f;
            	
            	for(String f : fragments) {
            		f = f.trim();
            		String xyz[] = f.split(" ");

            		x = Float.parseFloat(xyz[1]);
            		y = Float.parseFloat(xyz[2]);
            		z = Float.parseFloat(xyz[3]);
            		
            		sequence.add(new Vec3(x, y, z));
            	}
            	
            	sequences.add(sequence);
            }
            
            in.close();
            
        } catch (IOException e) {
            e.printStackTrace();
        }
		
		return sequences;
	}
	
	
	public static List<List<ObservationVector>> getObsVecSequences(String filename) {
		List<List<ObservationVector>> sequences = new ArrayList<List<ObservationVector>>();
		
		try {
            BufferedReader in = new BufferedReader(new FileReader(filename));
            String strLine = "";

            while((strLine = in.readLine()) != null) {
            	List<ObservationVector> sequence = new ArrayList<ObservationVector>();
            	
            	strLine = strLine.trim();
            	String fragments[] = strLine.split(";");
            	
            	float x = 0.0f;
            	float y = 0.0f;
            	float z = 0.0f;
            	
            	for(String f : fragments) {
            		f = f.trim();
            		String xyz[] = f.split(" ");

            		x = Float.parseFloat(xyz[1]);
            		y = Float.parseFloat(xyz[2]);
            		z = Float.parseFloat(xyz[3]);
            		
            		sequence.add(new ObservationVector(new double[] {x,y,z}));
            	}
            	
            	sequences.add(sequence);
            }
            
            in.close();
            
        } catch (IOException e) {
            e.printStackTrace();
        }
		
		return sequences;
	}
	
	
	public static List<List<NVec3>> getNVecSequences(String filename) {
		List<List<NVec3>> sequences = new ArrayList<List<NVec3>>();
		
		try {
            BufferedReader in = new BufferedReader(new FileReader(filename));
            String strLine = "";

            while((strLine = in.readLine()) != null) {
            	List<NVec3> sequence = new ArrayList<NVec3>();
            	
            	strLine = strLine.trim();
            	String fragments[] = strLine.split(";");
            	
            	float x = 0.0f;
            	float y = 0.0f;
            	float z = 0.0f;
            	
            	for(String f : fragments) {
            		f = f.trim();
            		String xyz[] = f.split(" ");

            		x = Float.parseFloat(xyz[1]);
            		y = Float.parseFloat(xyz[2]);
            		z = Float.parseFloat(xyz[3]);
            		
            		sequence.add(new NVec3(x, y, z));
            	}
            	
            	sequences.add(sequence);
            }
            
            in.close();
            
        } catch (IOException e) {
            e.printStackTrace();
        }
		
		return sequences;
	}
}
