package net.nexcius.gesturerecognizer.support;

import java.util.List;

import net.nexcius.gesturerecognizer.inputypes.NVec3;
import net.nexcius.gesturerecognizer.inputypes.Vec3;

public class VecComparators {

	public static double compareVec3Sequences(List<Vec3> a, List<Vec3> b) {
		int minCount = (a.size() < b.size()) ? a.size() : b.size();
        float aStep = (float)a.size() / (float)minCount;
        float bStep = (float)b.size() / (float)minCount;
        
        double result = 1.0f;
        
        for(int i = 0; i < minCount; i++) {
            int ai = (int) Math.round((aStep * (float)i));
            int bi = (int) Math.round((bStep * (float)i));

            result *= a.get(ai).simliarity(b.get(bi));
        }
        
		return Math.min(result, 1.0);
	}
	
	public static double compareNVec3Sequences(List<NVec3> a, List<NVec3> b) {
		int minCount = (a.size() < b.size()) ? a.size() : b.size();
        float aStep = (float)a.size() / (float)minCount;
        float bStep = (float)b.size() / (float)minCount;
        
        double result = 1.0f;
        
        for(int i = 0; i < minCount; i++) {
            int ai = (int) Math.round((aStep * (float)i));
            int bi = (int) Math.round((bStep * (float)i));

            result *= a.get(ai).simliarity(b.get(bi));
        }
        
		return Math.min(result, 1.0);
	}
	
}
