package net.nexcius.gesturerecognizer.tests;

import java.util.List;

import be.ac.ulg.montefiore.run.jahmm.ObservationVector;

import net.nexcius.gesturerecognizer.HmmGR;
import net.nexcius.gesturerecognizer.LinearGR;
import net.nexcius.gesturerecognizer.LinearGrNorm;
import net.nexcius.gesturerecognizer.inputypes.NVec3;
import net.nexcius.gesturerecognizer.inputypes.Vec3;
import net.nexcius.gesturerecognizer.support.ResultList;

public class AccuracyTest {
	
	public static void LinearTest(String handle, LinearGR gr, List<String> expectedResults, List<List<Vec3>> vectorData) {
		if(expectedResults.size() != vectorData.size()) {
			System.out.println("Expedted results and vector data not of same size.");
			return;
		}
		
		int size = expectedResults.size();
		int tp = 0;
		int tn = 0;
		int fp = 0;
		int fn = 0;
		
		for(int i = 0; i < size; i++) {
			ResultList rl = gr.classify(vectorData.get(i));

			if(expectedResults.get(i).equalsIgnoreCase("NOISE")) {
				if(rl.getSize() == 0) {
					//System.out.println("NOISE RECOGNIZED AS NOISE");
					tn++;
				} else {
					//System.out.println("NOISE RECOGNIZED AS " + rl.getTopHandle());
					fp++;
				}
			} 
			else if (expectedResults.get(i).equalsIgnoreCase("RANDOM")) {
				if(rl.getSize() == 0) {
					//System.out.println("RANDOM MOVEMENT RECOGNIZED AS RANDOM MOVEMENT");
					tn++;
				} else {
					//System.out.println("RANDOM MOVEMENT RECOGNIZED AS " +  rl.getTopHandle());
					fp++;
				}
			}
			else {
				if(rl.getSize() == 0){
					//System.out.println(expectedResults.get(i) + " RECOGNIZED AS NOTHING");
					fn++;
				} 
				else if(expectedResults.get(i).equalsIgnoreCase(rl.getTopHandle())) {
					//System.out.println(expectedResults.get(i) + " RECOGNIZED AS " + rl.getTopHandle());
					tp++;
				}
				else {
					//System.out.println(expectedResults.get(i) + " RECOGNIZED AS " + rl.getTopHandle());
					fp++;
				}
			}
		}
		float Atp =(float)(tp) / (float)(tp + fp);
		float Atn = (float)(tn) / (float)(tn + fn);
		float Atot = (float)(tp + tn) / (float)(size);
		
		System.out.println(handle + " - TP: " + tp);
		System.out.println(handle + " - TN: " + tn);
		System.out.println(handle + " - FP: " + fp);
		System.out.println(handle + " - FN: " + fn);
		
		System.out.println(handle + " - Atp: " + Atp);
		System.out.println(handle + " - Atn: " + Atn);
		System.out.println(handle + " - Atot: " + Atot);
	}
	
	
	
	
	public static void HmmTest(String handle, HmmGR gr, List<String> expectedResults, List<List<ObservationVector>> vectorData) {
		if(expectedResults.size() != vectorData.size()) {
			System.out.println("Expedted results and vector data not of same size.");
			return;
		}
		
		int size = expectedResults.size();
		int tp = 0;
		int tn = 0;
		int fp = 0;
		int fn = 0;
		
		for(int i = 0; i < size; i++) {
			ResultList rl = gr.classify(vectorData.get(i));

			if(expectedResults.get(i).equalsIgnoreCase("NOISE")) {
				if(rl.getSize() == 0) {
					//System.out.println("NOISE RECOGNIZED AS NOISE");
					tn++;
				} else {
					//System.out.println("NOISE RECOGNIZED AS " + rl.getTopHandle());
					fp++;
				}
			} 
			else if (expectedResults.get(i).equalsIgnoreCase("RANDOM")) {
				if(rl.getSize() == 0) {
					//System.out.println("RANDOM MOVEMENT RECOGNIZED AS RANDOM MOVEMENT");
					tn++;
				} else {
					//System.out.println("RANDOM MOVEMENT RECOGNIZED AS " +  rl.getTopHandle());
					fp++;
				}
			}
			else {
				if(rl.getSize() == 0){
					//System.out.println(expectedResults.get(i) + " RECOGNIZED AS NOTHING");
					fn++;
				} 
				else if(expectedResults.get(i).equalsIgnoreCase(rl.getTopHandle())) {
					//System.out.println(expectedResults.get(i) + " RECOGNIZED AS " + rl.getTopHandle());
					tp++;
					
				}
				else {
					//System.out.println(expectedResults.get(i) + " RECOGNIZED AS " + rl.getTopHandle());
					fp++;
				}
			}
		}
		float Atp =(float)(tp) / (float)(tp + fp);
		float Atn = (float)(tn) / (float)(tn + fn);
		float Atot = (float)(tp + tn) / (float)(size);
		
		//System.out.println(tp + " " + tn + " " + fp + " " + fn);
		System.out.println(handle + " - TP: " + tp);
		System.out.println(handle + " - TN: " + tn);
		System.out.println(handle + " - FP: " + fp);
		System.out.println(handle + " - FN: " + fn);
		
		System.out.println(handle + " - Atp: " + Atp);
		System.out.println(handle + " - Atn: " + Atn);
		System.out.println(handle + " - Atot: " + Atot);
	}
	
	
	
	public static void LinearNVecTest(String handle, LinearGrNorm gr, List<String> expectedResults, List<List<NVec3>> vectorData) {
		if(expectedResults.size() != vectorData.size()) {
			System.out.println("Expedted results and vector data not of same size.");
			return;
		}
		
		int size = expectedResults.size();
		int tp = 0;
		int tn = 0;
		int fp = 0;
		int fn = 0;
		
		for(int i = 0; i < size; i++) {
			ResultList rl = gr.classify(vectorData.get(i));

			if(expectedResults.get(i).equalsIgnoreCase("NOISE")) {
				if(rl.getSize() == 0) {
					//System.out.println("NOISE RECOGNIZED AS NOISE");
					tn++;
				} else {
					//System.out.println("NOISE RECOGNIZED AS " + rl.getTopHandle());
					fp++;
				}
			} 
			else if (expectedResults.get(i).equalsIgnoreCase("RANDOM")) {
				if(rl.getSize() == 0) {
					//System.out.println("RANDOM MOVEMENT RECOGNIZED AS RANDOM MOVEMENT");
					tn++;
				} else {
					//System.out.println("RANDOM MOVEMENT RECOGNIZED AS " +  rl.getTopHandle());
					fp++;
				}
			}
			else {
				if(rl.getSize() == 0){
					//System.out.println(expectedResults.get(i) + " RECOGNIZED AS NOTHING");
					fn++;
				} 
				else if(expectedResults.get(i).equalsIgnoreCase(rl.getTopHandle())) {
					//System.out.println(expectedResults.get(i) + " RECOGNIZED AS " + rl.getTopHandle());
					tp++;
				}
				else {
					//System.out.println(expectedResults.get(i) + " RECOGNIZED AS " + rl.getTopHandle());
					fp++;
				}
			}
		}
		float Atp =(float)(tp) / (float)(tp + fp);
		float Atn = (float)(tn) / (float)(tn + fn);
		float Atot = (float)(tp + tn) / (float)(size);
		
		System.out.println(handle + " - TP: " + tp);
		System.out.println(handle + " - TN: " + tn);
		System.out.println(handle + " - FP: " + fp);
		System.out.println(handle + " - FN: " + fn);
		
		System.out.println(handle + " - Atp: " + Atp);
		System.out.println(handle + " - Atn: " + Atn);
		System.out.println(handle + " - Atot: " + Atot);
	}
}
