package net.nexcius.gesturerecognizer.tests;

import java.util.ArrayList;
import java.util.List;

import be.ac.ulg.montefiore.run.jahmm.ObservationVector;
import net.nexcius.gesturerecognizer.FileData;
import net.nexcius.gesturerecognizer.HmmGR;
import net.nexcius.gesturerecognizer.LinearGR;
import net.nexcius.gesturerecognizer.inputypes.Vec3;
import net.nexcius.gesturerecognizer.support.SequenceLoader;

public class Step1 {
	
	public static void LinearTest() {
		String identifier = "Raw data Linear";
    	LinearGR gr = new LinearGR();
    	//gr.setTreshold(0.005);
    	
    	long startTime = 0;
        long endTime = 0;

        
    	List<List<Vec3>> training_left = SequenceLoader.getVecSequences(FileData.training_filenames[0]);
		List<List<Vec3>> training_right = SequenceLoader.getVecSequences(FileData.training_filenames[1]);
		List<List<Vec3>> training_up = SequenceLoader.getVecSequences(FileData.training_filenames[2]);
		List<List<Vec3>> training_down = SequenceLoader.getVecSequences(FileData.training_filenames[3]);
		
    	
    	// Learning Time
    	startTime = System.nanoTime();
		gr.trainGesture(FileData.training_handles[0], training_left);
		gr.trainGesture(FileData.training_handles[1], training_right);
		gr.trainGesture(FileData.training_handles[2], training_up);
		gr.trainGesture(FileData.training_handles[3], training_down);
		endTime = System.nanoTime();
		
		System.out.println(identifier + " - Training Time: " + ((endTime - startTime) / 10E6) + "ms" );
		
		
		// Identification time
		List<List<Vec3>> seqs = new ArrayList<List<Vec3>>();
		
		seqs.add(SequenceLoader.getVecSequences(FileData.test_filenames[0]).get(0));
		seqs.add(SequenceLoader.getVecSequences(FileData.test_filenames[5]).get(0));
		seqs.add(SequenceLoader.getVecSequences(FileData.test_filenames[10]).get(0));
		seqs.add(SequenceLoader.getVecSequences(FileData.test_filenames[15]).get(0));
		seqs.add(SequenceLoader.getVecSequences(FileData.test_filenames[20]).get(0));
		
		startTime = System.nanoTime();
		gr.classify(seqs.get(0));
		gr.classify(seqs.get(1));
		gr.classify(seqs.get(2));
		gr.classify(seqs.get(3));
		gr.classify(seqs.get(4));
		endTime = System.nanoTime();
		
		System.out.println(identifier + " - Classify Time: " + ( ((endTime - startTime) / 5.0) / 10E6) + "ms" );
		
		
		// Accuraccy test
		List<String> expectedResults = new ArrayList<String>();
		List<List<Vec3>> vectorData = new ArrayList<List<Vec3>>();
		
		for(int i = 0; i < FileData.test_filenames.length; i++) {
			expectedResults.add(FileData.test_handles[i]);
			vectorData.add(SequenceLoader.getVecSequences(FileData.test_filenames[i]).get(0));
		}
		AccuracyTest.LinearTest(identifier, gr, expectedResults, vectorData);
	}
	

	public static void HmmTest() {
		String identifier = "Raw data HMMs";
		HmmGR gr = new HmmGR();
		//gr.setTreshold(1.0E-200);
    	
    	long startTime = 0;
        long endTime = 0;
        
        List<List<ObservationVector>> training_left = SequenceLoader.getObsVecSequences(FileData.training_filenames[0]);
		List<List<ObservationVector>> training_right = SequenceLoader.getObsVecSequences(FileData.training_filenames[1]);
		List<List<ObservationVector>> training_up = SequenceLoader.getObsVecSequences(FileData.training_filenames[2]);
		List<List<ObservationVector>> training_down = SequenceLoader.getObsVecSequences(FileData.training_filenames[3]);
        
        // Training time		
		startTime = System.nanoTime();
		gr.trainGesture(FileData.training_handles[0], training_left);
		gr.trainGesture(FileData.training_handles[1], training_right);
		gr.trainGesture(FileData.training_handles[2], training_up);
		gr.trainGesture(FileData.training_handles[3], training_down);
		
		endTime = System.nanoTime();
		
		System.out.println(identifier + " - Training Time: " + ((endTime - startTime) / 10E6) + "ms" );
		
		
		// Identification time
		List<List<ObservationVector>> seqs = new ArrayList<List<ObservationVector>>();
	
		seqs.add(SequenceLoader.getObsVecSequences(FileData.test_filenames[0]).get(0));
		seqs.add(SequenceLoader.getObsVecSequences(FileData.test_filenames[5]).get(0));
		seqs.add(SequenceLoader.getObsVecSequences(FileData.test_filenames[10]).get(0));
		seqs.add(SequenceLoader.getObsVecSequences(FileData.test_filenames[15]).get(0));
		seqs.add(SequenceLoader.getObsVecSequences(FileData.test_filenames[20]).get(0));
		
		startTime = System.nanoTime();
		gr.classify(seqs.get(0));
		gr.classify(seqs.get(1));
		gr.classify(seqs.get(2));
		gr.classify(seqs.get(3));
		gr.classify(seqs.get(4));
		endTime = System.nanoTime();
		
		System.out.println(identifier + " - Classify Time: " + ( ((endTime - startTime) / 5.0) / 10E6) + "ms" );
		
		
		// Accuraccy test
		List<String> expectedResults = new ArrayList<String>();
		List<List<ObservationVector>> vectorData = new ArrayList<List<ObservationVector>>();

		for(int i = 0; i < FileData.test_filenames.length; i++) {
			expectedResults.add(FileData.test_handles[i]);
			vectorData.add(SequenceLoader.getObsVecSequences(FileData.test_filenames[i]).get(0));
		}
	
		AccuracyTest.HmmTest(identifier, gr, expectedResults, vectorData);
	}
}
